from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import String, Boolean, Int, File, Directory

Ansible_V0_1_0 = CommandToolBuilder(tool="ansible", base_command=["ansible"], inputs=[ToolInput(tag="in_args", input_type=String(optional=True), prefix="--args", doc=InputDocumentation(doc="module arguments")), ToolInput(tag="in_ask_become_pass", input_type=Boolean(optional=True), prefix="--ask-become-pass", doc=InputDocumentation(doc="ask for privilege escalation password")), ToolInput(tag="in_ask_pass", input_type=Boolean(optional=True), prefix="--ask-pass", doc=InputDocumentation(doc="ask for SSH password")), ToolInput(tag="in_ask_su_pass", input_type=Boolean(optional=True), prefix="--ask-su-pass", doc=InputDocumentation(doc="ask for su password (deprecated, use become)")), ToolInput(tag="in_ask_sudo_pass", input_type=Boolean(optional=True), prefix="--ask-sudo-pass", doc=InputDocumentation(doc="ask for sudo password (deprecated, use become)")), ToolInput(tag="in_ask_vault_pass", input_type=Boolean(optional=True), prefix="--ask-vault-pass", doc=InputDocumentation(doc="ask for vault password")), ToolInput(tag="in_background", input_type=String(optional=True), prefix="--background", doc=InputDocumentation(doc="run asynchronously, failing after X seconds\n(default=N/A)")), ToolInput(tag="in_become", input_type=Boolean(optional=True), prefix="--become", doc=InputDocumentation(doc="run operations with become (nopasswd implied)")), ToolInput(tag="in_become_method", input_type=String(optional=True), prefix="--become-method", doc=InputDocumentation(doc="privilege escalation method to use (default=sudo),\nvalid choices: [ sudo | su | pbrun | pfexec | runas ]")), ToolInput(tag="in_become_user", input_type=String(optional=True), prefix="--become-user", doc=InputDocumentation(doc="run operations as this user (default=None)")), ToolInput(tag="in_check", input_type=Boolean(optional=True), prefix="--check", doc=InputDocumentation(doc="don't make any changes; instead, try to predict some\nof the changes that may occur")), ToolInput(tag="in_connection", input_type=String(optional=True), prefix="--connection", doc=InputDocumentation(doc="connection type to use (default=smart)")), ToolInput(tag="in_extra_vars", input_type=String(optional=True), prefix="--extra-vars", doc=InputDocumentation(doc="set additional variables as key=value or YAML/JSON")), ToolInput(tag="in_forks", input_type=Int(optional=True), prefix="--forks", doc=InputDocumentation(doc="specify number of parallel processes to use\n(default=5)")), ToolInput(tag="in_inventory_file", input_type=File(optional=True), prefix="--inventory-file", doc=InputDocumentation(doc="specify inventory host file\n(default=/etc/ansible/hosts)")), ToolInput(tag="in_limit", input_type=String(optional=True), prefix="--limit", doc=InputDocumentation(doc="further limit selected hosts to an additional pattern")), ToolInput(tag="in_list_hosts", input_type=Boolean(optional=True), prefix="--list-hosts", doc=InputDocumentation(doc="outputs a list of matching hosts; does not execute\nanything else")), ToolInput(tag="in_module_name", input_type=String(optional=True), prefix="--module-name", doc=InputDocumentation(doc="module name to execute (default=command)")), ToolInput(tag="in_module_path", input_type=File(optional=True), prefix="--module-path", doc=InputDocumentation(doc="specify path(s) to module library (default=None)")), ToolInput(tag="in_one_line", input_type=Boolean(optional=True), prefix="--one-line", doc=InputDocumentation(doc="condense output")), ToolInput(tag="in_poll", input_type=Int(optional=True), prefix="--poll", doc=InputDocumentation(doc="set the poll interval if using -B (default=15)")), ToolInput(tag="in_private_key", input_type=File(optional=True), prefix="--private-key", doc=InputDocumentation(doc="use this file to authenticate the connection")), ToolInput(tag="in_su", input_type=Boolean(optional=True), prefix="--su", doc=InputDocumentation(doc="run operations with su (deprecated, use become)")), ToolInput(tag="in_su_user", input_type=String(optional=True), prefix="--su-user", doc=InputDocumentation(doc="run operations with su as this user (default=root)\n(deprecated, use become)")), ToolInput(tag="in_sudo", input_type=Boolean(optional=True), prefix="--sudo", doc=InputDocumentation(doc="run operations with sudo (nopasswd) (deprecated, use\nbecome)")), ToolInput(tag="in_sudo_user", input_type=String(optional=True), prefix="--sudo-user", doc=InputDocumentation(doc="desired sudo user (default=root) (deprecated, use\nbecome)")), ToolInput(tag="in_timeout", input_type=Int(optional=True), prefix="--timeout", doc=InputDocumentation(doc="override the SSH timeout in seconds (default=10)")), ToolInput(tag="in_tree", input_type=Directory(optional=True), prefix="--tree", doc=InputDocumentation(doc="log output to this directory")), ToolInput(tag="in_user", input_type=String(optional=True), prefix="--user", doc=InputDocumentation(doc="connect as this user (default=root)")), ToolInput(tag="in_vault_password_file", input_type=File(optional=True), prefix="--vault-password-file", doc=InputDocumentation(doc="vault password file")), ToolInput(tag="in_verbose", input_type=Boolean(optional=True), prefix="--verbose", doc=InputDocumentation(doc="verbose mode (-vvv for more, -vvvv to enable\nconnection debugging)")), ToolInput(tag="in_host_pattern", input_type=String(), position=0, doc=InputDocumentation(doc=""))], outputs=[ToolOutput(tag="out_tree", output_type=Directory(optional=True), selector=InputSelector(input_to_select="in_tree", type_hint=File()), doc=OutputDocumentation(doc="log output to this directory"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Ansible_V0_1_0().translate("wdl", allow_empty_container=True)

